System_file;

Constant path_search 10;  !profondita' della ricerca del percorso, si sconsiglia di aumentarlo.
			!in caso si debba, potreste dover aumentare la lunghezza dell'array path (ora puo' accogliere 24 voci).
			!in ogni caso non dovrebbe superare i 36.

Class NPC
   with 
	movestarget,	! locazione da raggiungere
	moves_step 0,	! a che punto del percorso siamo nel movimento?
	moves_stop 0,	! vogliamo fermare l'npc?
	nextMovesThink 0,	! avviamo il daemon
	path_size 0,	! lunguezza del percorso calcolato verso un target
	path_stage,	! a che punto siamo nel calcolo del percorso
	path 0 0 0 0 0 0 0 0 0 0 0 0, ! il percorso calcolato
	casualties 4,	! probabilita' di spostarsi nei movimenti 1=100% 4=25%
	destination,	! la locazione verso cui si muove l'npc
	prepath 0 0 0 0 0 0 0 0 0 0 0 0,! percorso precalcolato
	when_exit,	! messaggio di entrata dell'npc
	when_enter,	! messaggio di uscita dell'npc
	moves_type,	! tipo di movimento
	doAtTarget,	! fai questo quando raggiungi la destinazione
	moves_think [;  ! daemon analogo a think ma dedicato ai movimenti.
		movesRoutine(self);
		!print "^(",(name) self, " now is in ", (name) parent(self), ").^";
			], 
   has ;

Constant RANDOM_MV 0;
Constant PRESET_MV 1;
Constant MOVETO_MV 2;

[movesRoutine npc;
	if (parent(npc)==0){ 
		print "^*** MiniNPC Error: movesRoutine  stata chiamata per l'oggetto '",npc, "' che ha parent==0 ***";
		rfalse;
	}
	if (npc.moves_stop==false) {
		switch (npc.moves_type) {
		   0: RandomMoves(npc);
		   1: PrePathMoves(npc);
		   2: MoveToTarget(npc);
		}
	} 
];


!entrypoint della libreria base
[BeforePrompt t; !aggiungiamo ad ogni turno una seconda propriet tipo think dedicata ai movimenti degli npc.
	objectloop (t provides moves_think && t ofclass NPC) {
            if ((t provides nextmovesThink && now >= t.nextMovesThink && t.nextMovesThink ~= 0) 
			|| ~~(t provides nextMovesThink)) {
                
		if (t provides nextMovesThink) {t.nextMovesThink = 0;}
                
		t.moves_think();
            }
        }
	!print "^next move think:",joe.nextMovesThink,"^";
];

!routine per far partire o fermare un npc.
[StartMoves npc type target; !type=0...Random;   type=1...PreSetPath target=locazione obiettivo
	StopMoves(npc);
	npc.nextMovesThink = now + 1;
	npc.moves_type=type;
	npc.moves_stop=false;
	if(target~=0)npc.movestarget=target;
	else npc.movestarget==0;
];

[StopMoves npc;
	npc.nextMovesThink=0;
	npc.moves_stop=true;
];

! Spostamenti verso un obiettivo********************
[MoveToTarget npc target loc i j p t;
	target=npc.movestarget;
	!print "Target: ",(name) target,"^";
	if (~~(target ofclass Room)) "ERRORE: la destinazione indicata in movestarget non  della classe Room "; 
	if (target==parent(npc)) {
		npc.path_size=0; !print "ARRIVATO"
		npc.moves_step=0;
		npc.path_stage=0;
		StopMoves(npc);
		npc.doAtTarget(); 
		rtrue;
	} 
	else if (npc.path_size==0) {FindTarget(npc, target);}
	else {  
		!muoviti!
		npc.nextMovesThink=now+1; 
		loc = parent(npc);
		ExplorePossibleDirections(npc);	
		!PrintPossibleDirections(npc); !per monitorare gli spostamenti
		if (random(npc.casualties)==1) {
			if (~~(npc provides path)) print_ret "ERRORE NON E' STATA CALCOLATA LA PROPRIETA' PREPATH PER ", (name) npc;
			i=npc.path_stage; !a che punto del percorso siamo?
			!print "Step: ", i;
			if (i>=npc.path_size) { 
				StopMoves(npc); 
				npc.doAtTarget(); 
			} else { 
				j=npc.&path-->(i);
				!print "^VOGLIO SPOSTARMI VERSO ",(name) j;
				for (t=0:t<loc.#posDir:t++) { 
					!print "^quante possibili direzioni:",loc.#posDir,"^";
					p=loc.&posDir-->t;
					!print "^TENTATIVO: ", (name) p, "^";
					if (p~=nothing && p ofclass Room && p==j) { !Se e' valida.
						if (~~(j ofclass Room)) {print "ATTENZIONE ", (name) j, "NON APPARTIENE ALLA CLASSE ROOM"; rtrue;}
						move npc to j;	
						npc.destination=j;
						npc.path_stage ++;
						if (loc==parent(player) && npc provides when_exit) PrintOrCommand(npc.when_exit);
						if (j==parent(player)&& npc provides when_enter) PrintOrCommand(npc.when_enter);
						break; !se hai trovato il movimento interrompi il ciclo.
					}
				}
			}
		} else rfalse;
	}
];



[FindTarget npc target		loc found	i l lf k j  ;
   objectloop (j provides link_points) j.link_points=0;
   npc.nextMovesThink=now+1; 
   loc=parent(npc);
   if (loc==target) {
	npc.path_size=0;StopMoves(npc);npc.doAtTarget(); !print "ARRIVATO";
	rtrue;
   };
   loc.link_points=1; 
   !print "^Locazione iniziale: ", (name)loc, " : ", loc.link_points," ^";
	
   for(i=1:i<=path_search:i++) {
      !print "^^step: ", i;
		
      objectloop (l provides link_points && l.link_points==i) {
         !print "^LOCAZIONE: ",(name) l, " punti: ",l.link_points,"^";
         ExploreLocDirections(l);
         !print "   Possibili direzioni:^";
			
         for (k=0:k<l.#posDir:k++) {
            lf=l.&posDir-->k;
            if (lf~=nothing && lf ofclass Room && lf.link_points==0) {
		!print "      -> ", (name)lf,"   punti: ";
		lf.link_points=(i+1);
		!print lf.link_points, "^";
            }
            if (lf==target) {
               found=true;
 !              print "^Trovato target : ",(name)lf,"^"; 
               break;
            }
         }

         if (found) break;
      }
      if (found) break;
   }
!   print "^Ho fatto ", i , " passi.^";
   npc.path_size=i;
   CreatePath(npc, target);
];

[CreatePath npc target steps found i l lf k;
	!print "RIEPILOGO:^";objectloop (t ofclass Room) {print (name)t, " punti: ", t.link_points; print "^";}
	steps=(npc.path_size - 1); !print "^Steps nell'array: ", steps, " : ";
	l=target; !print (name) l;
	npc.&path-->(steps) = target;
	for(k=0:k<npc.path_size:k++) {!print "^Ciclo K: ",k, " su passi: ",npc.path_size;
			ExploreLocDirections(l);
			if(~~(l ofclass Room) || ~~(l provides posDir)) "ERRORE SCELTA UNA NON LOCAZIONE!";
			for(i=0:i<l.#posDir:i++){
				lf=l.&posDir-->i;
				!print "^Cerchiamo locazioni con punteggio: ",(steps+1);
				found=false;
				if (lf ofclass Room && lf provides link_points && lf.link_points==(steps+1)) {
					if(steps<1) break;
					!print "^Steps nell'array: ", (steps - 1), " : ";
					npc.&path-->(steps-1) = lf;
					found=true;
					l=lf;
					!print (name) l;
					steps--;
				}
				if (found) break;
			}
	}
!	print "^Percorso: ^";
!	for(k=0:k<npc.#path:k++) print (name) npc.&path-->k, " ";
];


[ExploreLocDirections loc i j;
	!print "^*ESPLORA LE DIREZIONI...^";
	if (~~(loc provides directions)) rfalse;
        for (i = 0: i <= loc.#directions / WORD_SIZE: i++) {
		!print (loc.#directions / WORD_SIZE),"^";
		!print i;
            do { 
                i++; !print i;
            } until (loc.&directions-->i == 0);
	    
            i++; !print i, "^";
	    if (loc.&directions-->i ofclass room) {
		!print "*Trovata direzione: ", (name) loc.&directions-->i;
		if (loc.&directions-->i ofclass Room) loc.&posDir-->j = loc.&directions-->i;
		!print "^",(name)loc.&posDir-->j," immagazzinata in array alla posizione: ", j, "^^";
		j++;
	    }
        }
	!print "POSDIR= ";
	!for (j=0:j<loc.#posDir:j++) print (name) loc.&posDir-->j, " - ";
	!print "^";
	rfalse;
];


! spostamenti random*********************************
[RandomMoves npc loc i j t;
	npc.nextMovesThink=now+1;
	loc = parent(npc);
	ExplorePossibleDirections(npc);
	!PrintPossibleDirections(npc); !per monitorare gli spostamenti
	for(t=0:t<loc.#posDir:t++) {
		if (loc.&posDir-->t~=nothing && loc.&PosDir-->t ofclass Room) i++;
	}
	!print "i= ",i,"^";
	if (random(npc.casualties)==1) {
		if (i>0) {
			t=random(i);
			j=loc.&posDir-->(t-1);
			!print "si sposta verso ",(name) j,"^"; !per controllare la decisione
			npc.destination=j;
			if (j ofclass room) move npc to j;
			else print "Errore, tentativo di spostare ", (name) npc, " in ", (name) j, " che non  una locazione.";
			if (loc==parent(player) && npc provides when_exit) PrintOrCommand(npc.when_exit);
			if (j==parent(player)&& npc provides when_enter) PrintOrCommand(npc.when_enter);
		} else rfalse; !print (name) npc, " non pu muoversi.";
	} else rfalse;
];

! spostamenti su un percorso dato*****************************
[PrePathMoves npc loc i j p t;
	npc.nextMovesThink=now+1; !il demone  attivo ogni turno
	loc = parent(npc);	  !la locazione dell'npc
	ExplorePossibleDirections(npc);	!cerca lo possibili direzioni in cui si pu muovere
	!PrintPossibleDirections(npc); !per monitorare gli spostamenti
   if (random(npc.casualties)==1) {
	if (~~(npc provides prepath)) print_ret "ERRORE NON HAI DEFINITO LA PROPRIETA' PREPATH PER ", (name) npc;
	!print "Prepath: ";for (i=0:i<npc.#prepath/WORD_SIZE:i++){print (name) npc.&prepath-->i, "; ";}
	!print "^";
	i=npc.moves_step; !a che punto del percorso siamo?
	!print "^Step: ", i;
	if (i>=(npc.#prepath/WORD_SIZE)) { !se si arriva all fine del percorso
		StopMoves(npc); !esci dalla modalita' movimento
		npc.doAtTarget(); !fai qualcosa a destinazione
	} else { !altrimenti
		j=npc.&prepath-->(i);	!prendi la MOVES_STEP(esima) locazione indicata nell'array PREPATH
		!print "^VOGLIO SPOSTARMI VERSO ",(name) j;
		for (t=0:t<loc.#posDir:t++) { !controlla che la locazione in cui ci si vuole muovere sia valida
			!print "^quante possibili direzioni:",loc.#posDir,"^";
			p=loc.&posDir-->t;
			!print "^TENTATIVO: ", (name) p, "^";
			if (p~=nothing && p ofclass Room && p==j) { !Se e' valida.
				if (~~(j ofclass Room)) {print "ATTENZIONE ", (name) j, "NON APPARTIENE ALLA CLASSE ROOM"; rtrue;}
				move npc to j;	!sposta l'npc
				npc.destination=j; !registra la destinazione
				npc.moves_step ++; !passa allo step successivo nel percorso
				!se previste negli spostamenti richiama i messaggi when_exit when_enter
				if (loc==parent(player) && npc provides when_exit) PrintOrCommand(npc.when_exit);
				if (j==parent(player)&& npc provides when_enter) PrintOrCommand(npc.when_enter);
				break; !se hai trovato il movimento interrompi il ciclo.
			}
		}
	}
   } else rfalse;
];

[ExplorePossibleDirections npc		loc i j;
	loc=parent(npc);
	if (~~(loc provides directions)) rfalse;
        for (i = 0: i < loc.#directions / WORD_SIZE: i++) {
            do { 
                i++;
            } until (loc.&directions-->i == 0);            
            i++;
	    if (loc.&directions-->i ofclass room) {loc.&posDir-->j = loc.&directions-->i;j++;}
!	    print i; print "-";
!	    print j; print " "; print (name) npc.&posDir-->(j-1);
!	    print "^";
        }
	rfalse;
];

! routine per controllare le possibili direzioni di npc in loc
![PrintPossibleDirections npc loc i ;!c
!	loc=parent(npc); print (name) npc, " is in ", (name) loc,"^";
	!c=npc.casualties();
	!c=(100/c);
	!print "casualties = ", c, "%^";
!	print "Possible directions:^";
!	for (i=0:i<loc.#posDir:i++){
!		print i+1,") ";
!		print (name) loc.&posDir-->i;
!		print "; ";
!	}
!	print "^";
!];
