! tutor.h, libreria per suggerimenti nel corso dell'avventura
!          Paolo Lucchesi, 2003
!
! ----------------------------------------------------------------------------
!
! Per usare il tutor:
!   - Mettete il comando < Include "tutor"; > immediatamente dopo
!     < Include "replace"; >
!
!   - Definite dopo < Include "italiang.h"; > questa riga:
!         Verb meta 'tutor' 'guida' * -> Tutor;
!
!   - Definite una funzione Tutor con un singolo argomento, che stampi le
!     istruzioni a seconda del numero contenuto nell'argomento. Se la routine
!     restituisce true, in futuro non verranno piu' mostrate le istruzioni
!     relative a quel numero.
!
!   - Chiamate la funzione DoTutor(<numero>) per stampare le istruzioni 
!     relative a <numero>.
!
!   - In alternativa chiamate la funzione DoTutor(<num>, <stringa>) per 
!     stamparela stringa di istruzioni, senza bisogno di definire la funzione 
!     tutor. In questo caso vengono sempre trascurate ulteriori chiamate con 
!     lo stesso numero.
!
! ----------------------------------------------------------------------------
!
! Questo file e' software libero, puo' essere liberamente usato, copiato,
! distribuito e modificato. Qualsiasi versione, modificata o meno, di questo
! file distribuita sotto forma di codice sorgente deve contenere riferimento
! all'autore originale e deve essere liberamente usabile, copiabile,
! distribuibile e modificabile.
! Non e' posta alcuna condizione alla distribuzione del file come codice
! compilato.
! Questo file e' distribuito senza alcuna garanzia. L'autore non puo'
! essere ritenuto responsabile in alcun modo di danni provocati
! direttamente o indirettamente da questo file.
!
! ----------------------------------------------------------------------------

Array tflag->32;
Global tutorflag=true;

[ DoTutor num str i j p;
    if (~~tutorflag) rfalse;
    if (num>255) rfalse;
    i = num / 8;
    j = num % 8;
    p = twopower(j);
    if (tflag->i & p) rfalse;
    style underline;
    print "^";
    if (str>0)   { 
        print (string) str; 
        tflag->i = (tflag->i | p);
    }
    else        
        if (Tutor(num)) tflag->i = (tflag->i | p);
    ! print num, ", ", i, ", ", p, ", ", tflag->i; !
    print "^";
    style roman;
    rtrue;
];

[ asktflag num i j p;
    if (num>255) rfalse;
    i = num / 8;
    j = num % 8;
    p = twopower(j);
    if (tflag->i & p) rtrue;
    rfalse;
];
    
[ settflag num i j p;
    if (num>255) rfalse;
    i = num / 8;
    j = num % 8;
    p = twopower(j);
    tflag->i = (tflag->i | p);
    rtrue;
];

[ resettflag num i j p;
    if (num>255) rfalse;
    i = num / 8;
    j = num % 8;
    p = twopower(j);
    p = ((~p) & 255);
    tflag->i = (tflag->i & p);
    rtrue;
];

[ twopower a;
    switch(a) {
    0:  return $$000000001;
    1:  return $$000000010;
    2:  return $$000000100;
    3:  return $$000001000;
    4:  return $$000010000;
    5:  return $$000100000;
    6:  return $$001000000;
    7:  return $$010000000;
    }
    return(0);
];

[ tutordothfake;
    DoTutor();
    asktflag();
    settflag();
    resettflag();
    tutordothfake();
];
    

[TutorSub;
    if (tutorflag) {
        tutorflag = false;
        "[Il Tutor ora @`e disattivato.]";
    }
    tutorflag = true;
    "[Il Tutor ora @`e attivo.]";
];
